<?php
namespace PME\Modules\Planejamento\Prato;

// use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DTO\Response\Error;


class RevisarQuantidadeController extends \PME\Services\TeknisaCrud {
	protected $crudService;
	protected $parameterBag;
    protected $utilities;
    protected $connection;
    protected $newCode;
    protected $environment;
    
    public function __construct($crudService, $parameterBag, $utilities, $connection, $newCode, $environment) {
        $this->utilities     = $utilities;
        $this->connection    = $connection;
        $this->newCode     = $newCode;
        $this->environment = $environment;
        parent::__construct($crudService, $parameterBag);
    }
    
    public function revisarQtd(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $nrorg = $this->utilities->getNrOrg();
            $codLista = $this->newCode->getCodeByTableName('LISTA', $nrorg);
            $tipoReceita = $row['TPRECEITA'];
            $fator = $row['FATORAJUS'];
            $qtd = $row['QUANTIDADE'];
            $parameters = $request->getParameters();
            $rows = $parameters['rowsGrid'];
            // $cdfilcentpme = $parameters['cdfilcentpme']['CDFILCENTPME'];
            $cdfilcentpme = $parameters['cdfilcentpme'];

            if($fator == 'P') {
                $qtd =  1 + ($qtd/100);    
            }
            
            if ($tipoReceita == 'S') {
                $servico = $row['SERVICO'];
                $filial = $row['UNIDADE'];
                $tipocard = 'X';
            } else if ($tipoReceita == 'L') {
                $servico = 'X';
                $filial = $row['UNIDADE'];
                $tipocard = 'X';
            } else if ($tipoReceita == 'C') {
                $servico = 'X';
                $filial = 'X';
                $tipocard = $row['TIPOCARD'];
            } else {
                $servico = 'X';
                $filial = 'X';
                $tipocard = 'X';
            }
            
            $data = $this->environment->getCurrentTime()->format('d/m/Y');

            foreach ($rows as $pratos) {
                $dados = array('NRLISTA' => $codLista, 'CDLISTA' => $pratos['CDFILAUXPRAT'].$pratos['CDPRATO'], '__is_new' => true, 'DTULTATULIST' => $data);
                $requestLista = new \Zeedhi\Framework\DTO\Request\Row($dados, '', '', '');
                $dadosLista = $this->crudService->getRowsToSave($requestLista, "lista");
                $this->crudService->save("lista", $dadosLista);
            }

            //$connection = $this->entityManager->getConnection();
            //$revisao = new StoredProcedure($connection, 'REVISA_QTDE');
            $revisao = new StoredProcedure($this->connection, 'REVISA_QTDE');
            $revisao->addParam(new Param('P_NRLISTA',      Param::PARAM_INPUT, $codLista,    Param::PARAM_TYPE_STR));
            $revisao->addParam(new Param('P_IDTIPORECE',   Param::PARAM_INPUT, $tipoReceita, Param::PARAM_TYPE_STR));
            $revisao->addParam(new Param('P_IDOPCAO',      Param::PARAM_INPUT, $fator,       Param::PARAM_TYPE_STR));
            $revisao->addParam(new Param('P_VRVALOR',      Param::PARAM_INPUT, $qtd,         Param::PARAM_TYPE_STR));
            $revisao->addParam(new Param('P_CDFILIAL',     Param::PARAM_INPUT, $filial,      Param::PARAM_TYPE_STR));
            $revisao->addParam(new Param('P_CDSERVFILI',   Param::PARAM_INPUT, $servico,     Param::PARAM_TYPE_STR));
            $revisao->addParam(new Param('P_CDFILCENTPME', Param::PARAM_INPUT, $cdfilcentpme,Param::PARAM_TYPE_STR));
            $revisao->addParam(new Param('P_CDTIPOCARD',   Param::PARAM_INPUT, $tipocard,    Param::PARAM_TYPE_STR));
            
            $revisao->execute();

            $response->addDataset(new DataSet_Source('RETORNO', array(true)));

        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
  
    
}
