/* Tabela ALIQUOTA: Alquota */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela ALIQUOTA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Alquota,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIS_ALIQUOTA
AFTER DELETE OR INSERT OR UPDATE
ON ALIQUOTA FOR EACH ROW
DECLARE
  V_DSREMOTEADDR   VARCHAR2(15);
  V_DSREMOTEHOST   VARCHAR2(15);
  V_DSSERVERRDM    VARCHAR2(20);
  V_DSSERVMETHOD   VARCHAR2(30);
  V_DSREMOTEOPER   VARCHAR2(12);
  V_USUARIO        VARCHAR2(40);
  V_TIPO           VARCHAR2(1);
  V_ITPESQ         VARCHAR2(40);
  V_DESC           VARCHAR2(300);
  V_DTOPER         DATE;
  V_IDTIPO         VARCHAR2(1);
  V_CDARVPROD      VARCHAR2(20);
  V1_CDARVPROD     VARCHAR2(20);
  VANT_CDARVPROD   VARCHAR2(20);
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN
      IF :OLD.CDIMPOSTO IS NOT NULL THEN
         V_DESC := V_DESC || 'Impo=' || :OLD.CDIMPOSTO;
      END IF;

      IF :OLD.CDEMPRESA IS NOT NULL THEN
         V_DESC := V_DESC || ' Empr=' || :OLD.CDEMPRESA;
      END IF;

      IF :OLD.CDINSCESTA IS NOT NULL THEN
         V_DESC := V_DESC || ' InscEsta=' || :OLD.CDINSCESTA;
      END IF;
   
      IF :OLD.CDPRODUTO IS NOT NULL THEN
         SELECT MAX(CDARVPROD) INTO V_CDARVPROD
         FROM PRODUTO
         WHERE CDPRODUTO = :OLD.CDPRODUTO;
         IF V_CDARVPROD IS NOT NULL THEN
           V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
         END IF;
      END IF;
      
      IF :OLD.CDPAISORIG IS NOT NULL THEN
         V_DESC := V_DESC || ' PaisOrig=' || :OLD.CDPAISORIG;
      END IF;

      IF :OLD.SGESTAORIG IS NOT NULL THEN
         V_DESC := V_DESC || ' EstaOrig=' || :OLD.SGESTAORIG;
      END IF;

      IF :OLD.CDMUNIORIG IS NOT NULL THEN
         V_DESC := V_DESC || ' Municip=' || :OLD.CDMUNIORIG;
      END IF;

      IF :OLD.CDPAISDEST IS NOT NULL THEN
         V_DESC := V_DESC || ' PaisDest=' || :OLD.CDPAISDEST;
      END IF;

      IF :OLD.SGESTADEST IS NOT NULL THEN
         V_DESC := V_DESC || ' EstaDest=' || :OLD.SGESTADEST;
      END IF;

      IF :OLD.DTINIVALID IS NOT NULL THEN
         V_DESC := V_DESC || ' DtIniVal=' || :OLD.DTINIVALID;
      END IF;

      IF :OLD.VRINIFAIXA IS NOT NULL THEN
         V_DESC := V_DESC || ' IniFaixa=' || :OLD.VRINIFAIXA;
      END IF;

      IF :OLD.VRFIMFAIXA IS NOT NULL THEN
         V_DESC := V_DESC || ' FimFaixa=' || :OLD.VRFIMFAIXA;
      END IF;

      IF :OLD.VRPARDEDUZ IS NOT NULL THEN
         V_DESC := V_DESC || ' ParcDedu=' || :OLD.VRPARDEDUZ;
      END IF;

      IF :OLD.VRPERREDBC IS NOT NULL THEN
         V_DESC := V_DESC || ' PerRecBC=' || :OLD.VRPERREDBC;
      END IF;

      IF :OLD.VRALIQUOTA IS NOT NULL THEN
         V_DESC := V_DESC || ' Aliq=' || :OLD.VRALIQUOTA;
      END IF;

      IF :OLD.CDGRUPOFISC IS NOT NULL THEN
         V_DESC := V_DESC || ' GrupFisc=' || :OLD.CDGRUPOFISC;
      END IF;

      IF :OLD.IDTRATIMPST IS NOT NULL THEN
         V_DESC := V_DESC || ' TratImpST=' || :OLD.IDTRATIMPST;
      END IF;

      IF :OLD.VRPBCSUBTRIB IS NOT NULL THEN
         V_DESC := V_DESC || ' BCSitTrib=' || :OLD.VRPBCSUBTRIB;
      END IF;

      IF :OLD.IDMUNIORIDES IS NOT NULL THEN
         V_DESC := V_DESC || ' MunOrigDest=' || :OLD.IDMUNIORIDES;
      END IF;

      IF :OLD.IDENTRSAIDAL IS NOT NULL THEN
         V_DESC := V_DESC || ' IdEntrSaid=' || :OLD.IDENTRSAIDAL;
      END IF;

      IF :OLD.CDTIPOOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' CdTipoOper=' || :OLD.CDTIPOOPER;
      END IF;

      IF :OLD.VR1PERREDBC IS NOT NULL THEN
         V_DESC := V_DESC || ' 1PerRedBC=' || :OLD.VR1PERREDBC;
      END IF;

      IF :OLD.CDMUNIDEST IS NOT NULL THEN
         V_DESC := V_DESC || ' MuniDest=' || :OLD.CDMUNIDEST;
      END IF;

      V_TIPO := '3';
      V_ITPESQ := :OLD.NRALIQUOTA;
   ELSE
      IF UPDATING THEN
         SELECT MAX(CDARVPROD) INTO V1_CDARVPROD
         FROM PRODUTO
         WHERE CDPRODUTO = :NEW.CDPRODUTO;

         SELECT MAX(CDARVPROD) INTO VANT_CDARVPROD
           FROM PRODUTO
          WHERE CDPRODUTO = :OLD.CDPRODUTO;

         IF (NVL(:NEW.CDIMPOSTO, '!')    <> NVL(:OLD.CDIMPOSTO, '!'))    OR
            (NVL(:NEW.CDEMPRESA, '!')    <> NVL(:OLD.CDEMPRESA, '!'))    OR
            (NVL(:NEW.CDINSCESTA, '!')   <> NVL(:OLD.CDINSCESTA, '!'))   OR
            (NVL(:NEW.CDPRODUTO, '!')    <> NVL(:OLD.CDPRODUTO, '!'))    OR
            (NVL(:NEW.CDPAISORIG, '!')  <> NVL(:OLD.CDPAISORIG, '!'))   OR
            (NVL(:NEW.SGESTAORIG, '!')   <> NVL(:OLD.SGESTAORIG, '!'))   OR
            (NVL(:NEW.CDMUNIORIG, '!')   <> NVL(:OLD.CDMUNIORIG, '!'))   OR
            (NVL(:NEW.CDPAISDEST, '!')   <> NVL(:OLD.CDPAISDEST, '!'))   OR
            (NVL(:NEW.SGESTADEST, '!')   <> NVL(:OLD.SGESTADEST, '!'))   OR
            (NVL(:NEW.DTINIVALID, TO_DATE(NULL))   <> NVL(:OLD.DTINIVALID, TO_DATE(NULL)))   OR
            (NVL(:NEW.VRINIFAIXA, 0)   <> NVL(:OLD.VRINIFAIXA, 0))   OR
            (NVL(:NEW.VRFIMFAIXA, 0)   <> NVL(:OLD.VRFIMFAIXA, 0))   OR
            (NVL(:NEW.VRPARDEDUZ, 0)   <> NVL(:OLD.VRPARDEDUZ, 0))   OR
            (NVL(:NEW.VRPERREDBC, 0)   <> NVL(:OLD.VRPERREDBC, 0))   OR
            (NVL(:NEW.VRALIQUOTA, 0)   <> NVL(:OLD.VRALIQUOTA, 0))   OR
            (NVL(:NEW.CDGRUPOFISC, '!')  <> NVL(:OLD.CDGRUPOFISC, '!'))  OR
            (NVL(:NEW.IDTRATIMPST, '!')  <> NVL(:OLD.IDTRATIMPST, '!'))  OR
            (NVL(:NEW.VRPBCSUBTRIB, 0) <> NVL(:OLD.VRPBCSUBTRIB, 0)) OR
            (NVL(:NEW.IDMUNIORIDES, '!') <> NVL(:OLD.IDMUNIORIDES, '!')) OR
            (NVL(:NEW.IDENTRSAIDAL, '!') <> NVL(:OLD.IDENTRSAIDAL, '!')) OR
            (NVL(:NEW.CDTIPOOPER, '!')   <> NVL(:OLD.CDTIPOOPER, '!'))   OR
            (NVL(:NEW.VR1PERREDBC, 0)  <> NVL(:OLD.VR1PERREDBC, 0))  OR
            (NVL(:NEW.CDMUNIDEST, '!')   <> NVL(:OLD.CDMUNIDEST, '!'))  THEN

            V_TIPO   := '2';
            V_ITPESQ := :OLD.NRALIQUOTA;
         END IF;
      ELSE
         SELECT MAX(CDARVPROD) INTO V1_CDARVPROD
         FROM PRODUTO
         WHERE CDPRODUTO = :NEW.CDPRODUTO;

         SELECT MAX(CDARVPROD) INTO VANT_CDARVPROD
           FROM PRODUTO
          WHERE CDPRODUTO = :OLD.CDPRODUTO;

         V_TIPO   := '1';
         V_ITPESQ := :NEW.NRALIQUOTA;
      END IF;

      IF NVL(:OLD.CDIMPOSTO, '!') <> NVL(:NEW.CDIMPOSTO, '!') THEN
         V_DESC := V_DESC || 'Impo=' || :NEW.CDIMPOSTO;
      END IF;

      IF NVL(:OLD.CDEMPRESA, '!') <> NVL(:NEW.CDEMPRESA, '!') THEN
         V_DESC := V_DESC || ' Empr=' || :NEW.CDEMPRESA;
      END IF;

      IF NVL(:OLD.CDINSCESTA, '!') <> NVL(:NEW.CDINSCESTA, '!') THEN
         V_DESC := V_DESC || ' InscEsta=' || :NEW.CDINSCESTA;
      END IF;

      IF NVL(V1_CDARVPROD, '!') <> NVL(VANT_CDARVPROD, '!') THEN
         V_DESC := V_DESC || ' Prod=' || V1_CDARVPROD;
      END IF;

      IF NVL(:OLD.CDPAISORIG, '!') <> NVL(:NEW.CDPAISORIG, '!') THEN
         V_DESC := V_DESC || ' PaisOrig=' || :NEW.CDPAISORIG;
      END IF;

      IF NVL(:OLD.SGESTAORIG, '!') <> NVL(:NEW.SGESTAORIG, '!') THEN
         V_DESC := V_DESC || ' EstaOrig=' || :NEW.SGESTAORIG;
      END IF;

      IF NVL(:OLD.CDMUNIORIG, '!') <> NVL(:NEW.CDMUNIORIG, '!') THEN
         V_DESC := V_DESC || ' Municip=' || :NEW.CDMUNIORIG;
      END IF;

      IF NVL(:OLD.CDPAISDEST, '!') <> NVL(:NEW.CDPAISDEST, '!') THEN
         V_DESC := V_DESC || ' PaisDest=' || :NEW.CDPAISDEST;
      END IF;

      IF NVL(:OLD.SGESTADEST, '!') <> NVL(:NEW.SGESTADEST, '!') THEN
         V_DESC := V_DESC || ' EstaDest=' || :NEW.SGESTADEST;
      END IF;

      IF NVL(:OLD.DTINIVALID, TO_DATE(NULL)) <> NVL(:NEW.DTINIVALID, TO_DATE(NULL)) THEN
         V_DESC := V_DESC || ' DtIniVal=' || :NEW.DTINIVALID;
      END IF;

      IF NVL(:OLD.VRINIFAIXA, 0) <> NVL(:NEW.VRINIFAIXA, 0) THEN
         V_DESC := V_DESC || ' IniFaixa=' || :NEW.VRINIFAIXA;
      END IF;

      IF NVL(:OLD.VRFIMFAIXA, 0) <> NVL(:NEW.VRFIMFAIXA, 0) THEN
         V_DESC := V_DESC || ' FimFaixa=' || :NEW.VRFIMFAIXA;
      END IF;

      IF NVL(:OLD.VRPARDEDUZ, 0) <> NVL(:NEW.VRPARDEDUZ, 0) THEN
         V_DESC := V_DESC || ' ParcDedu=' || :NEW.VRPARDEDUZ;
      END IF;

      IF NVL(:OLD.VRPERREDBC, 0) <> NVL(:NEW.VRPERREDBC, 0) THEN
         V_DESC := V_DESC || ' PerRecBC=' || :NEW.VRPERREDBC;
      END IF;

      IF NVL(:OLD.VRALIQUOTA, 0) <> NVL(:NEW.VRALIQUOTA, 0) THEN
         V_DESC := V_DESC || ' Aliq=' || :NEW.VRALIQUOTA;
      END IF;

      IF NVL(:OLD.CDGRUPOFISC, '!') <> NVL(:NEW.CDGRUPOFISC, '!') THEN
         V_DESC := V_DESC || ' GrupFisc=' || :NEW.CDGRUPOFISC;
      END IF;

      IF NVL(:OLD.IDTRATIMPST, '!') <> NVL(:NEW.IDTRATIMPST, '!') THEN
         V_DESC := V_DESC || ' TratImpST=' || :NEW.IDTRATIMPST;
      END IF;

      IF NVL(:OLD.VRPBCSUBTRIB, 0) <> NVL(:NEW.VRPBCSUBTRIB, 0) THEN
         V_DESC := V_DESC || ' BCSitTrib=' || :NEW.VRPBCSUBTRIB;
      END IF;

      IF NVL(:OLD.IDMUNIORIDES, '!') <> NVL(:NEW.IDMUNIORIDES, '!') THEN
         V_DESC := V_DESC || ' MunOrigDest=' || :NEW.IDMUNIORIDES;
      END IF;

      IF NVL(:OLD.IDENTRSAIDAL, '!') <> NVL(:NEW.IDENTRSAIDAL, '!') THEN
         V_DESC := V_DESC || ' IdEntrSaid=' || :NEW.IDENTRSAIDAL;
      END IF;

      IF NVL(:OLD.CDTIPOOPER, '!') <> NVL(:NEW.CDTIPOOPER, '!') THEN
         V_DESC := V_DESC || ' CdTipoOper=' || :NEW.CDTIPOOPER;
      END IF;

      IF NVL(:OLD.VR1PERREDBC, 0) <> NVL(:NEW.VR1PERREDBC, 0) THEN
         V_DESC := V_DESC || ' 1PerRedBC=' || :NEW.VR1PERREDBC;
      END IF;

      IF NVL(:OLD.CDMUNIDEST, '!') <> NVL(:NEW.CDMUNIDEST, '!') THEN
         V_DESC := V_DESC || ' MuniDest=' || :NEW.CDMUNIDEST;
      END IF;

   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('ALIQUOTA',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST,
                V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIS_ALIQUOTA','5.75.XXX'); END;
/
